/*
 * ----------------------------------------------------------------
 * ircproxy - Access Configuration Header
 * ----------------------------------------------------------------
 * Copyright (C) 1997-2009 Jonas Kvinge
 *
 * This file is part of ircproxy.
 *
 * ircproxy is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * ircproxy is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with ircproxy.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Additional permission under GNU GPL version 3 section 7
 *
 * If you modify ircproxy, or any covered work, by linking or
 * combining it with openssl (or a modified version of that library),
 * containing parts covered by the terms of the OpenSSL License and the
 * SSLeay License, the licensors of ircproxy grant you additional
 * permission to convey the resulting work.
 *
 * $Id: access_conf.h 54 2009-03-18 18:23:29Z jonasio $
 *
 */

#ifdef ACCESS_CONF_H
#warning "access_conf.h already included."
#else
#define ACCESS_CONF_H

#define ACCESS_ALLOW 1
#define ACCESS_DENY 2

#define ACCESS_CONF_NOREASON				"No reason given."
#define ACCESS_CONF_USERFLOOD				"User flooding detected."
#define ACCESS_CONF_SENDQFLOOD				"Maximum allowed SendQ exceeded"

/* STRUCTURES - JONAS (18.07.2001) */

struct AccessConf_Struct {

  char *Host;
  char *Reason;

  struct AccessConf_Struct *Prev;
  struct AccessConf_Struct *Next;

};

/* FUNCTION PROTOTYPES - JONAS (18.07.2001) */

signed long int access_conf_read(void);
struct AccessConf_Struct *access_conf_addallow(const char *const HostPT, const char *const ReasonPT);
void access_conf_remallow(struct AccessConf_Struct *AccessConf);
struct AccessConf_Struct *access_conf_adddeny(const char *const HostPT, const char *const ReasonPT);
void access_conf_remdeny(struct AccessConf_Struct *AccessConf);
void access_conf_destroy(void);

#endif
