/*
 * ----------------------------------------------------------------
 * ircproxy - Auto-OP Configuration Header
 * ----------------------------------------------------------------
 * Copyright (C) 2007-2008 Jonas Kvinge
 *
 * This file is part of ircproxy.
 *
 * ircproxy is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * ircproxy is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with ircproxy.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Additional permission under GNU GPL version 3 section 7
 *
 * If you modify ircproxy, or any covered work, by linking or
 * combining it with openssl (or a modified version of that library),
 * containing parts covered by the terms of the OpenSSL License and the
 * SSLeay License, the licensors of ircproxy grant you additional
 * permission to convey the resulting work.
 *
 * $Id: autoop_conf.h 54 2009-03-18 18:23:29Z jonasio $
 *
 */

#ifdef AUTOOP_CONF_H
#warning "autoop_conf.h already included."
#else
#define AUTOOP_CONF_H

/* STRUCTURES - JONAS (25.11.2007) */

struct AutoOPConf_Struct {

  char *NUH;
  char *Connection;

  unsigned long int Chans;

  struct AutoOPConf_Struct *Prev;
  struct AutoOPConf_Struct *Next;

  struct AutoOPConfChan_Struct *Chan_Head;
  struct AutoOPConfChan_Struct *Chan_Tail;

};

struct AutoOPConfChan_Struct {

  char *Chan;

  struct AutoOPConfChan_Struct *Prev;
  struct AutoOPConfChan_Struct *Next;

};

/* FUNCTION PROTOTYPES - JONAS (25.11.2007) */

signed long int autoop_conf_read(void);
struct AutoOPConf_Struct *autoop_conf_add(const char *const NUHPT, const char *const ConnectionPT);
void autoop_conf_rem(struct AutoOPConf_Struct *AutoOPConf);
struct AutoOPConfChan_Struct *autoop_conf_addchan(struct AutoOPConf_Struct *AutoOPConf, const char *const ChanPT);
void autoop_conf_remchan(struct AutoOPConf_Struct *AutoOPConf, struct AutoOPConfChan_Struct *AutoOPConfChan);
void autoop_conf_destroy(void);

#endif
