/*
 * ----------------------------------------------------------------
 * ircproxy - Bitmasks
 * ----------------------------------------------------------------
 * Copyright (C) 1997-2009 Jonas Kvinge
 *
 * This file is part of ircproxy.
 *
 * ircproxy is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * ircproxy is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with ircproxy.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Additional permission under GNU GPL version 3 section 7
 *
 * If you modify ircproxy, or any covered work, by linking or
 * combining it with openssl (or a modified version of that library),
 * containing parts covered by the terms of the OpenSSL License and the
 * SSLeay License, the licensors of ircproxy grant you additional
 * permission to convey the resulting work.
 *
 * $Id: bitmasks.h 54 2009-03-18 18:23:29Z jonasio $
 *
 */

#ifdef BITMASKS_H
#warning "bitmasks.h already included."
#else
#define BITMASKS_H

#define BITMASK_MAIN			1
#define BITMASK_ERROR			2
#define BITMASK_DEBUG			4

#define BITMASK_EXTRA			8
#define BITMASK_CONF			BITMASK_EXTRA


#define BITMASK_DEBUG001		1
#define BITMASK_DEBUG002		2
#define BITMASK_DEBUG003		4
#define BITMASK_DEBUG004		8
#define BITMASK_DEBUG005		16
#define BITMASK_DEBUG006		32
#define BITMASK_DEBUG007		64
#define BITMASK_DEBUG008		128
#define BITMASK_DEBUG009		256
#define BITMASK_DEBUG010		512
#define BITMASK_DEBUG011		1024
#define BITMASK_DEBUG012		2048
#define BITMASK_DEBUG013		4096
#define BITMASK_DEBUG014		8192
#define BITMASK_DEBUG015		16384
#define BITMASK_DEBUG016		32768
#define BITMASK_DEBUG017		65536
#define BITMASK_DEBUG018		131072

#define BITMASK_DEBUG_GENERAL		BITMASK_DEBUG001
#define BITMASK_DEBUG_FUNCTION		BITMASK_DEBUG002
#define BITMASK_DEBUG_FLAGS		BITMASK_DEBUG003
#define BITMASK_DEBUG_MEMORY		BITMASK_DEBUG004
#define BITMASK_DEBUG_FD		BITMASK_DEBUG005
#define BITMASK_DEBUG_SYSCALLS		BITMASK_DEBUG006
#define BITMASK_DEBUG_STRCALLS		BITMASK_DEBUG007
#define BITMASK_DEBUG_IRCCALLS		BITMASK_DEBUG008
#define BITMASK_DEBUG_MAIN		BITMASK_DEBUG009
#define BITMASK_DEBUG_ARES		BITMASK_DEBUG010
#define BITMASK_DEBUG_CONF		BITMASK_DEBUG011
#define BITMASK_DEBUG_LISTEN		BITMASK_DEBUG012
#define BITMASK_DEBUG_CLIENT		BITMASK_DEBUG013
#define BITMASK_DEBUG_CONN		BITMASK_DEBUG014
#define BITMASK_DEBUG_CONN_RECV		BITMASK_DEBUG015
#define BITMASK_DEBUG_CONN_SENDQ	BITMASK_DEBUG016
#define BITMASK_DEBUG_CONN_SEND		BITMASK_DEBUG017
#define BITMASK_DEBUG_IDENTD		BITMASK_DEBUG018

#define BITMASK_DEBUG_OPTIONS		(BITMASK_DEBUG_GENERAL \
					|BITMASK_DEBUG_FUNCTION \
					|BITMASK_DEBUG_FLAGS \
					|BITMASK_DEBUG_MAIN \
					|BITMASK_DEBUG_CONF \
					|BITMASK_DEBUG_LISTEN \
					|BITMASK_DEBUG_CLIENT \
					|BITMASK_DEBUG_CONN \
					|BITMASK_DEBUG_IDENTD \
					)

#endif
