/*
 * ----------------------------------------------------------------
 * ircproxy - Client Connection Header
 * ----------------------------------------------------------------
 * Copyright (C) 1997-2009 Jonas Kvinge
 *
 * This file is part of ircproxy.
 *
 * ircproxy is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * ircproxy is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with ircproxy.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Additional permission under GNU GPL version 3 section 7
 *
 * If you modify ircproxy, or any covered work, by linking or
 * combining it with openssl (or a modified version of that library),
 * containing parts covered by the terms of the OpenSSL License and the
 * SSLeay License, the licensors of ircproxy grant you additional
 * permission to convey the resulting work.
 *
 * $Id: client_connection.h 54 2009-03-18 18:23:29Z jonasio $
 *
 */

#ifdef CLIENT_CONNECTION_H
#warning "client_connection.h already included."
#else
#define CLIENT_CONNECTION_H

struct hostent;
struct Listen_Struct;

/* FUNCTION PROTOTYPES - JONAS (18.07.2001) */

void client_resolve(struct Client_Struct *ClientS);
#if HAVE_CARES_CALLBACK_TIMEOUTS
void client_hostiptoname(void *ArgPT, int ErrNo, int Timeouts, struct hostent *HostEnt);
void client_hostnametoip(void *ArgPT, int ErrNo, int Timeouts, struct hostent *HostEnt);
#else
void client_hostiptoname(void *ArgPT, int ErrNo, struct hostent *HostEnt);
void client_hostnametoip(void *ArgPT, int ErrNo, struct hostent *HostEnt);
#endif
void client_addsend(struct Client_Struct *ClientS, const char *const LinePT, ...) __attribute__ ((format (printf, 2, 3)));
void client_close(struct Client_Struct *ClientS, const char *const LinePT, ...) __attribute__ ((format (printf, 2, 3)));
void client_cleanup(struct Client_Struct *ClientS, const char *const LinePT, ...) __attribute__ ((format (printf, 2, 3)));
unsigned short int client_closeall(const char *const MessagePT, ...) __attribute__ ((format (printf, 1, 2)));

#endif
