/*
 * ----------------------------------------------------------------
 * ircproxy - Connection Ignore Header
 * ----------------------------------------------------------------
 * Copyright (C) 1997-2009 Jonas Kvinge
 *
 * This file is part of ircproxy.
 *
 * ircproxy is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * ircproxy is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with ircproxy.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Additional permission under GNU GPL version 3 section 7
 *
 * If you modify ircproxy, or any covered work, by linking or
 * combining it with openssl (or a modified version of that library),
 * containing parts covered by the terms of the OpenSSL License and the
 * SSLeay License, the licensors of ircproxy grant you additional
 * permission to convey the resulting work.
 *
 * $Id: conn_ignore.h 54 2009-03-18 18:23:29Z jonasio $
 *
 */

#ifdef CONN_IGNORE_H
#warning "conn_ignore.h already included."
#else
#define CONN_IGNORE_H

/* STRUCTURES - JONAS (18.07.2001) */

struct Ignore_Struct {

  unsigned short int Type;
  char *NUH;
  time_t ExpireTime;

  struct Ignore_Struct *Prev;
  struct Ignore_Struct *Next;

};

/* FUNCTION PROTOTYPES - JONAS (18.07.2001) */

struct Ignore_Struct *conn_addignore(struct Conn_Struct *ConnS, const char *const NUHPT);
void conn_remignore(struct Conn_Struct *ConnS, struct Ignore_Struct *IgnoreS);
struct Ignore_Struct *conn_getignore(struct Conn_Struct *ConnS, const char *const NUHPT);
void conn_ignoreexpire(struct Conn_Struct *ConnS);
void conn_destroyignores(struct Conn_Struct *ConnS);

#endif
