/*
 * ----------------------------------------------------------------
 * ircproxy - Connection SendQ Header
 * ----------------------------------------------------------------
 * Copyright (C) 1997-2009 Jonas Kvinge
 *
 * This file is part of ircproxy.
 *
 * ircproxy is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * ircproxy is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with ircproxy.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Additional permission under GNU GPL version 3 section 7
 *
 * If you modify ircproxy, or any covered work, by linking or
 * combining it with openssl (or a modified version of that library),
 * containing parts covered by the terms of the OpenSSL License and the
 * SSLeay License, the licensors of ircproxy grant you additional
 * permission to convey the resulting work.
 *
 * $Id: conn_sendq.h 54 2009-03-18 18:23:29Z jonasio $
 *
 */

#ifdef CONN_SENDQ_H
#warning "conn_sendq.h already included."
#else
#define CONN_SENDQ_H

/* STRUCTURES - JONAS (18.07.2001) */

struct SendQ_Struct {

  char *Line;
  unsigned short int Priority;
  time_t Time;

  struct SendQ_Struct *Next;

};

struct FlushL_Struct {

  unsigned short int Lines;
  time_t Time;

  struct FlushL_Struct *Prev;
  struct FlushL_Struct *Next;

};

struct FlushB_Struct {

  unsigned short int Len;
  time_t Time;

  struct FlushB_Struct *Prev;
  struct FlushB_Struct *Next;

};

/* FUNCTION PROTOTYPES - JONAS (18.07.2001) */

void conn_addsendq(struct Conn_Struct *ConnS, const char *const LinePT, ...) __attribute__ ((format (printf, 2, 3)));
void conn_flushsendq(struct Conn_Struct *ConnS);
void conn_initsendq(struct Conn_Struct *ConnS);

void conn_addflushl(struct Conn_Struct *ConnS, const unsigned short int Lines);
void conn_initflushl(struct Conn_Struct *ConnS);

void conn_addflushb(struct Conn_Struct *ConnS, const unsigned short int Len);
void conn_initflushb(struct Conn_Struct *ConnS);

#endif
