/*
 * ----------------------------------------------------------------
 * Ident Daemon - Configuration Header
 * ----------------------------------------------------------------
 * Copyright (C) 1997-2009 Jonas Kvinge
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * $Id: ident_conf.h 54 2009-03-18 18:23:29Z jonasio $
 *
 */

#ifdef IDENT_CONF_H
#warning "ident_conf.h already included."
#else
#define IDENT_CONF_H

/* STRUCTURES - JONAS (03.07.2003) */

struct IdentConf_Struct {

  char *Host;
  unsigned long int Port;
  unsigned short int IPv6;

  struct IdentConf_Struct *Next;
  struct IdentConf_Struct *Prev;

};

/* FUNCTION PROTOTYPES - JONAS (03.07.2003) */

signed long int ident_conf_read(void);
struct IdentConf_Struct *ident_conf_add(const char *const HostPT, const unsigned long int Port, unsigned short int IPv6);
void ident_conf_rem(struct IdentConf_Struct *IdentConf);
struct IdentConf_Struct *ident_conf_get(const char *const HostPT, const unsigned long int Port);
void ident_conf_destroy(void);

#endif
