/*
 * ----------------------------------------------------------------
 * IRC Events
 * ----------------------------------------------------------------
 * Copyright (C) 1997-2009 Jonas Kvinge
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * $Id: irc_events.h 54 2009-03-18 18:23:29Z jonasio $
 *
 *
 */

#ifdef IRC_EVENTS_H
#warning "irc_events.h already included."
#else
#define IRC_EVENTS_H


#define IRC_EVENT_NONE							0

#define IRC_EVENT_PRIVMSG						'b'
#define IRC_EVENT_ACTION						'a'
#define IRC_EVENT_CTCP							'c'
#define IRC_EVENT_NOTICE						'd'
#define IRC_EVENT_NICK							'n'
#define IRC_EVENT_QUIT							'q'
#define IRC_EVENT_MODE							'm'
#define IRC_EVENT_INVITE						'i'
#define IRC_EVENT_JOIN							'j'
#define IRC_EVENT_PART							'p'
#define IRC_EVENT_KICK							'k'
#define IRC_EVENT_TOPIC							't'
#define IRC_EVENT_KILL							'e'
#define IRC_EVENT_WALLOPS						'w'
#define IRC_EVENT_VOICE							'v'
#define IRC_EVENT_OP							'o'

#define IRC_EVENT_NICKFROM						'n'
#define IRC_EVENT_NICKTO						'y'
#define IRC_EVENT_KICKED						'x'


#define IRC_BITMASK_PRIVMSG						1
#define IRC_BITMASK_ACTION						2
#define IRC_BITMASK_CTCP						4
#define IRC_BITMASK_NOTICE						8
#define IRC_BITMASK_NICK						16
#define IRC_BITMASK_QUIT						32
#define IRC_BITMASK_MODE						64
#define IRC_BITMASK_INVITE						128
#define IRC_BITMASK_JOIN						256
#define IRC_BITMASK_PART						512
#define IRC_BITMASK_KICK						1024
#define IRC_BITMASK_TOPIC						2048
#define IRC_BITMASK_KILL						4096
#define IRC_BITMASK_WALLOPS						8192
#define IRC_BITMASK_VOICE						16384
#define IRC_BITMASK_OP							32768

#define IRC_BITMASK_NICKFROM						65536
#define IRC_BITMASK_NICKTO						131072
#define IRC_BITMASK_KICKED						262144

#endif
