/*
 * ----------------------------------------------------------------
 * irccalls - IRC Functions Header
 * ----------------------------------------------------------------
 * Copyright (C) 1997-2009 Jonas Kvinge
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * $Id: irccalls.h 54 2009-03-18 18:23:29Z jonasio $
 *
 *
 */

#ifdef IRCCALLS_H
#warning "irccalls.h already included."
#else
#define IRCCALLS_H


#define IRC_UNKNOWNEVENT					"Unknown IRC event: \"%c\"."
#define IRC_EVENTTWOTIMESINSTRING				"IRC event \"%c\" appears two times in string."
#define IRC_NICKINVALIDSTARTCHAR				"Invalid starting character \"%c\" in nickname."
#define IRC_NICKINVALIDCHAR					"Invalid character \"%c\" in nickname."
#define IRC_NICKMAXCHARS					"Maximum %d characters in nickname."
#define IRC_USERINVALIDCHAR					"Invalid character \"%c\" in username."
#define IRC_USERMAXCHARS					"Maximum %d characters in username."
#define IRC_HOSTINVALIDCHAR					"Invalid character \"%c\" in hostname."
#define IRC_HOSTMAXCHARS					"Maximum %d characters in hostname."
#define IRC_NUHINVALIDCHAR					"Invalid character \"%c\" in NICK!USER@HOST."
#define IRC_NUHMAXCHARS						"Maximum %d characters in NICK!USER@HOST."
#define IRC_SERVERINVALIDCHAR					"Invalid character \"%c\" in server."
#define IRC_SERVERMAXCHARS					"Maximum %d characters in server."
#define IRC_PASSINVALIDCHAR					"Invalid character \"%c\" in password."
#define IRC_PASSMAXCHARS					"Maximum %d characters in password."
#define IRC_TARGETINVALIDCHAR					"Invalid character \"%c\" in target."
#define IRC_TARGETMAXCHARS					"Maximum %d characters in target."
#define IRC_CHANINVALIDSTARTCHAR				"Invalid starting character \"%c\" in channel name."
#define IRC_CHANINVALIDCHAR					"Invalid character \"%c\" in channel name."
#define IRC_CHANMAXCHARS					"Maximum %d characters in channel name."
#define IRC_CHANTOPICMAXCHARS					"Maximum %d characters in channel topic name."
#define IRC_CHANKEYMAXCHARS					"Maximum %d characters in channel key name."
#define IRC_UNKNOWNUSERMODEFLAG					"Unknown user mode flag: \"%c\"."
#define IRC_USERMODESTWOTIMESINSTRING				"User mode \"%c\" appears more then once in user modes."
#define IRC_UNKNOWNCHANMODEFLAG					"Unknown channel mode flag: \"%c\"."
#define IRC_CHANMODESTWOTIMESINSTRING				"Channel mode \"%c\" appears more then once in user modes."
#define IRC_UNKNOWNCHANEVENT					"Unknown channel event \"%c\"."
#define IRC_CHANEVENTTWOTIMESINSTRING				"Channel event \"%c\" appears more than once in string."
#define IRC_MSGMAXCHARS						"Maximum %d characters in a IRC message."

/* FUNCTION PROTOTYPES - JONAS (26.09.2000) */

unsigned short int irc_isvalidevents(const char * const StringPT);
unsigned short int irc_isvalidnick(const char *const StringPT, unsigned short int MaxNickLen);
unsigned short int irc_isvaliduser(const char *const StringPT, unsigned short int MaxUserLen);
unsigned short int irc_isvalidhost(const char * const StringPT);
unsigned short int irc_isvalidnuh(const char * const StringPT);
unsigned short int irc_isvalidserver(const char * const StringPT);
unsigned short int irc_isvalidpass(const char * const StringPT);
unsigned short int irc_isvalidtarget(const char *const StringPT);
unsigned short int irc_isvalidchan(const char * const StringPT);
unsigned short int irc_isvalidchantopic(const char * const StringPT);
unsigned short int irc_isvalidchankey(const char * const StringPT);
unsigned short int irc_isvalidusermodes(const char * const StringPT);
unsigned short int irc_isvalidchanmodes(const char * const StringPT);
unsigned short int irc_isvalidchanevents(const char * const StringPT);
unsigned short int irc_isvalidmsg(const char *const StringPT);
const char *irc_strevent(const char Event);
char *irc_nuhmask(const char *NickPT, const char *UserPT, const char *HostPT, const unsigned short int NickMask, const unsigned short int UserMask, const unsigned short int HostMask, unsigned short int MaxNickLen, unsigned short int MaxUserLen, unsigned short int MaxHostLen);
char *irc_fixnuh(char *NUHPT);
void irc_nuhmastest(void);
unsigned short int irc_createnick(const char *const NickPT, unsigned short int NicksIndex, const unsigned short int MaxNickLen);
void irc_cleanup(void);


#endif
