/*
 * ----------------------------------------------------------------
 * ircproxy - Header
 * ----------------------------------------------------------------
 * Copyright (C) 1997-2009 Jonas Kvinge
 *
 * This file is part of ircproxy.
 *
 * ircproxy is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * ircproxy is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with ircproxy.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Additional permission under GNU GPL version 3 section 7
 *
 * If you modify ircproxy, or any covered work, by linking or
 * combining it with openssl (or a modified version of that library),
 * containing parts covered by the terms of the OpenSSL License and the
 * SSLeay License, the licensors of ircproxy grant you additional
 * permission to convey the resulting work.
 *
 * $Id: ircproxy.h 54 2009-03-18 18:23:29Z jonasio $
 *
 */

#ifdef IRCPROXY_H
#warning "ircproxy.h already included."
#else
#define IRCPROXY_H

struct hostent;

#define PACKAGE						PACKAGE_NAME
#define VERSION						PACKAGE_VERSION
#define UNIXNAME					PACKAGE
#define SHORTNAME					"ircproxy"
#define LONGNAME					"IRC Proxy/Bouncer"
#define DESCRIPTION					"Internet Relay Chat Proxy"
#define AUTHORNAME					"Jonas Kvinge"
#define AUTHORMAIL					"jonas@night-light.net"
#define URL						"http://www.ircproxy.sourceforge.net/"
#define COPYRIGHT					"by Jonas Kvinge"
#define STARTUPLN1					SHORTNAME " v" VERSION
#define STARTUPLN2					COPYRIGHT

#define NLPRGSEC					3
#define NLPRGUSEC					0

#define EXITTTL						10
#define FLUSHTIME					45

#ifndef SOMAXCONN
  #define SOMAXCONN 64
#endif

#define IRCP_USER_HOST(X)				(((X->ListenS != NULL) && (X->ListenS->Host != NULL) && (strcmp(X->ListenS->Host, "*") != FALSE) && (strcmp(X->ListenS->Host, "0.0.0.0") != FALSE)) ? X->ListenS->Host : HOSTNAME)
#define IRCP_USER_NICK(X)				(((X->ConnS != NULL) && (Conn_IsWelcome(X->ConnS))) ? X->ConnS->IRCNick : "*")

#ifndef NBLOCK_SYSV
  #ifndef NBLOCK_BSD
    #ifndef NBLOCK_POSIX
      #define NBLOCK_POSIX 1
    #endif
  #endif
#endif

#endif
